#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <time.h>

#include "state.h"

clock_t ftime;

P newPT(void);
#include "dp.c"

char cstack[800000];
P pstack[800000], *stack;

int mergetext(P tr)
{
  P L=NULL,R=NULL;
  P *stkbase;
  char *cl, *cr;

  stkbase=stack;

  *stack++=tr;
  while(1)
  {
mergetext_start:
    if((*(stack-1))->txt!=NULL)
    {
      L=R;
      R = *(stack-1);
      if(L!=NULL)
      {
	if(!statediff(L->state,R->state,NULL))
	{
	  for(cl=L->txt; *cl; cl++);
	  cr=R->txt; while((*cl++=*cr++));
	  R->txt=NULL;
	  L->optimal &= (R->optimal|~OPT_WS);
	  R=L;
	}
	else
	{
	  if(R->optimal&OPT_WS)
	  {
	    if(!spacestatediff(L->state,R->state,NULL))
	    {
	      for(cl=L->txt; *cl; cl++);
	      cr=R->txt; while((*cl++=*cr++));
	      R->txt=NULL;
	      L->optimal &= (R->optimal|~OPT_WS);
	      R=L;
	    }
	    
	  }
	  else if(L->optimal&OPT_WS)
	  {
	    if(!spacestatediff(R->state,L->state,NULL))
	    {
	      for(cl=L->txt; *cl; cl++);
	      cr=R->txt; while((*cl++=*cr++));
	      R->txt=L->txt;
	      L->txt=NULL;
	      R->optimal &= ~OPT_WS;
	    }
	  }

	  /*	   else if(L->optimal&OPT_WS)
		   {
		   for(cl=L->txt; *cl; cl++)
		   if(!isspace(*cl))
		   fprintf(stderr, "asdfasf\n");

		   }*/
	}
      }
    }
    if((*(stack-1))->chld!=NULL)
    {
      *stack++ = (*(stack-1))->chld;
      goto mergetext_start;
    }
mergetext_next:
    if((*(stack-1))->next!=NULL)
    {
      *stack++ = (*(stack-1))->next;
      goto mergetext_start;
    }
mergetext_upstack:
    stack--;
    if(*stack==tr)
      break;
    if(*stack == (*(stack-1))->chld)
      goto mergetext_next;
    goto mergetext_upstack;
  }
  if(stack!=stkbase) fprintf(stderr,"stack failed in mergetext!\n");
  if(*stack!=tr) fprintf(stderr,"stack may have failed in mergetext!\n");
  return 0;
}

int killspace(P tr)
{
  char *cl, *cr;
  State lastspst=HI, spst;
  char lastsp=0;
  P *stkbase;

  stkbase=stack;

  *stack++=tr;
  while(1)
  {
killspace_start:
    if((*(stack-1))->txt!=NULL)
    {
      spst = (*(stack-1))->state;
      if(F_TT & spst)
      {
	lastsp=0;
      }
      else
      {
	for(cl=cr=(*(stack-1))->txt; *cr; cr++)
	{
	  if(isspace(*cr))
	  {
	    if(!lastsp || spacestatediff(lastspst, spst, NULL))
	    {
	      *cl++ = ' ';
	    }
	    lastsp=1;
	    lastspst=spst;
	  }
	  else
	  {
	    *cl++ = *cr;
	    lastsp=0;
	  }
	}
	*cl = 0;
      }
    }
    if((*(stack-1))->chld!=NULL)
    {
      *stack++ = (*(stack-1))->chld;
      goto killspace_start;
    }
killspace_next:
    if((*(stack-1))->next!=NULL)
    {
      *stack++ = (*(stack-1))->next;
      goto killspace_start;
    }
killspace_upstack:
    stack--;
    if(*stack==tr)
      break;
    if(*stack == (*(stack-1))->chld)
      goto killspace_next;
    goto killspace_upstack;
  }
  if(stack!=stkbase) fprintf(stderr,"stack failed in mergetext!\n");
  if(*stack!=tr) fprintf(stderr,"stack may have failed in mergetext!\n");
  return 0;
}

int countleaf(P tr)
{
  P *stkbase, N, tmp;

  stkbase=stack;

  *stack++=tr;
  while(1)
  {
countleaf_start:
    if((*(stack-1))->chld!=NULL)
    {
      *stack++ = (*(stack-1))->chld;
      goto countleaf_start;
    }
countleaf_next:
    if((*(stack-1))->next!=NULL)
    {
      *stack++ = (*(stack-1))->next;
      goto countleaf_start;
    }
countleaf_upstack:
    stack--;

    N = *stack;
    if((N->optimal&OPT_OPT))
      N->leaves=1;
    else
    {
      N->leaves=0;
      for(tmp=N->chld; tmp; tmp=tmp->next)
	N->leaves+=tmp->leaves;
    }

    if(*stack==tr)
      break;
    if(*stack == (*(stack-1))->chld)
      goto countleaf_next;
    goto countleaf_upstack;
  }
  if(stack!=stkbase) fprintf(stderr,"stack failed in mergetext!\n");
  if(*stack!=tr) fprintf(stderr,"stack may have failed in mergetext!\n");
  return 0;
}

int compresstwig(P tr)
{
  P N, tmp;
  P *stkbase;
  stkbase=stack;

  *stack++=tr;
  while(1)
  {
compresstrig_start:
    if((*(stack-1))->chld!=NULL)
    {
      *stack++ = (*(stack-1))->chld;
      goto compresstrig_start;
    }
compresstwig_next:
    if((*(stack-1))->next!=NULL)
    {
      *stack++ = (*(stack-1))->next;
      goto compresstrig_start;
    }
compresstwig_upstack:
    stack--;

    if((N = *stack))
      while(N->chld!=NULL && N->chld->next==NULL && N->chld->txt==NULL)
      {
	transtrans(N->trans, N->chld->trans, &(N->trans));
	N->optimal = N->chld->optimal;
	N->txt = NULL;
	tmp = N->chld;
	N->chld = N->chld->chld;
	free(tmp);
      }

    if(*stack==tr)
      break;

    if((*stack)->chld==NULL && (*stack)->txt==NULL)
    {
      if((*(stack-1))->chld == (*stack))
      {
	(*(stack-1))->chld = (*stack)->next;
	free(*stack);
	*stack = (*(stack-1))->chld;
      }
      else //   if((*(stack-1))->next == (*stack))  // - is always true
      {
	(*(stack-1))->next = (*stack)->next;
	free(*stack);
	*stack = (*(stack-1))->next;
      }
    }

    if(*stack == (*(stack-1))->chld)
      goto compresstwig_next;
    goto compresstwig_upstack;
  }
  if(stack!=stkbase) fprintf(stderr,"stack failed in mergetext!\n");
  if(*stack!=tr) fprintf(stderr,"stack may have failed in mergetext!\n");
  return 0;
}

P newPT()
{
  P ret;

  ret = (P) malloc(sizeof(ParseTree));
  ret->chld = NULL;
  ret->next = NULL;
  ret->state = HI;
  ret->trans = 0;
  ret->optimal = 0;
  ret->txt = NULL;

  return ret;
}

int movetreelocal(P tr)
{
  P N, to, bto=NULL;
  int fromcst, tocst, bcst, btrans=0, trans, tp=0;
  P *stkbase, *st2;
  stkbase=stack;

  *stack++=tr;
  while(1)
  {
movetreelocal_start:

    if(ftime < clock())
    {
      stack=stkbase;

//      fprintf(stderr, "Time out!!\n");

      return 1;
    }


    if((*(stack-1))->chld!=NULL)
    {
      *stack++ = (*(stack-1))->chld;
      goto movetreelocal_start;
    }
movetreelocal_next:

    N = *(stack-1);
    bcst = 0;
    tp=0;
    if(N != tr)
    if(N==(*(stack-2))->chld)
    {
      fromcst=statediff((*(stack-2))->state, N->state, NULL);        // Find shift left
      for(st2=stack-2; *st2!=tr && (*st2)->next != *(st2+1); st2--);
      if((*st2)->next == *(st2+1))
      {
	to = (*st2)->chld;
	while(to)
	{
	  while(to->next) to=to->next;
	  tocst=statediff(to->state, N->state, &trans);
	  if(bcst > tocst - fromcst)
	  {
	    bcst=tocst-fromcst; bto = to; btrans=trans; tp=1;
	  }
	  to=to->chld;
	}
      }
      if(*(stack-2) != tr)                                           // Find shift right
      {
	to = (*(stack-2))->next;
	if(to)
	while(to->chld)
	{
	  tocst=statediff(to->chld->state, N->state, &trans);
	  if(bcst > tocst - fromcst)
	  {
	    bcst=tocst-fromcst; bto = to; btrans=trans; tp=2;
	  }
	  to=to->chld;
	}
      }
/*
if(tp) { printf("%08x %08x tp=%d\n", N->state, bto->state, tp);
printtree(tr);
printf("\n\n"); }
*/

      if(tp==1)                                                       // Do shift left
      {
	if((*(stack-3))->chld == (*(stack-2)))
	  (*(stack-3))->chld = (*(stack-2))->next;
	else if((*(stack-3))->next == (*(stack-2)))
	  (*(stack-3))->next = (*(stack-2))->next;
	else
	  fprintf(stderr, "Stack problem\n");

	if((btrans&LO)==0)
	{
	  bto->next = N;
	  bto->next->state = bto->state;   // not sure about don't care bits
	  free(*(stack-2));
	}
	else
	{
	  bto->next = *(stack-2);
	  bto->next->state = bto->state;   // not sure about don't care bits
	  bto->next->trans = btrans;
	  bto->next->next = NULL;
	}
	stack = st2+1;
	to = (*st2)->chld;
	while(to)
	{
	  *stack++ = to;
	  if(to==N) break;
	  if(to->next) to=to->next; 
	  else if(to->chld) to=to->chld; 
	  else fprintf(stderr, "can't find N\n");
	}
	if(to!=N) fprintf(stderr, "can't find N\n");
      }
      else if(tp==2)                                                       // Do shift right
      {
	if((*(stack-3))->chld == (*(stack-2)))
	{
	  (*(stack-3))->chld = (*(stack-2))->next;
	  tp=1;
	}
	else if((*(stack-3))->next == (*(stack-2)))
	{
	  (*(stack-3))->next = (*(stack-2))->next;
	  tp=2;
	}
	else
	  fprintf(stderr, "Stack problem\n");

	if((btrans&LO)==0)
	{
	  for(to=N; to->next; to=to->next);
	  to->next = bto->chld;
	  bto->chld = N;
	  statetrans(bto->state, bto->trans, &(bto->chld->state));   // not sure about don't care bits
	  free(*(stack-2));
	}
	else
	{
	  (*(stack-2))->next = bto->chld;
	  bto->chld = *(stack-2);
	  statetrans(bto->state, bto->trans, &(bto->chld->state));   // not sure about don't care bits
	  bto->chld->trans = btrans;
	}
	stack -= 2;
	if(tp==1) *stack++ = (*(stack-1))->chld;
	else if(tp==2) *stack++ = (*(stack-1))->next;

	to=(*(stack-1))->chld;
	while(to)
	{
	  *stack++ = to;
	  if(to==N) break;
	  if(to->chld) to=to->chld; 
	  else fprintf(stderr, "can't find N2\n");
	}
	if(to!=N) fprintf(stderr, "can't find N2\n");
      }
    }

    if((*(stack-1))->next!=NULL)
    {
      *stack++ = (*(stack-1))->next;
      goto movetreelocal_start;
    }
movetreelocal_upstack:
    stack--;

    if(*stack==tr)
      break;

    if(*stack == (*(stack-1))->chld)
      goto movetreelocal_next;
    goto movetreelocal_upstack;
  }
  if(stack!=stkbase) fprintf(stderr,"stack failed in mergetext!\n");
  if(*stack!=tr) fprintf(stderr,"stack may have failed in mergetext!\n");
  return 0;
}

int optimalizer(P tr)
{
  P N, N1, N2, tmp;
  P *stkbase;
  State s0, s1, s2;
  stkbase=stack;

  *stack++=tr;
  while(1)
  {
optimalizer_start:
    N = *(stack-1);
    if(N->next && N->txt==NULL && N->next->txt==NULL)
    {
      statetrans(N->state, N->trans, &s0);
      statetrans(N->next->state, N->next->trans, &s1);
      if(!statediff(s0,s1,NULL))
      {
	if(N->chld)
	{
	  for(tmp=N->chld; tmp->next; tmp=tmp->next);
	  tmp->next = N->next->chld;
	  N->next = N->next->next;
//	  fprintf(stderr, "N should have merged\n");
	}
//	else fprintf(stderr, "N should have child\n");
      }
    }

    if((*(stack-1))->chld!=NULL)
    {
      *stack++ = (*(stack-1))->chld;
      goto optimalizer_start;
    }
optimalizer_next:
    if((*(stack-1))->next!=NULL)
    {
      *stack++ = (*(stack-1))->next;
      goto optimalizer_start;
    }
optimalizer_upstack:
    stack--;

    N = *stack;

    if(N->txt || (N->chld && N->chld->next==NULL && (N->chld->optimal&OPT_OPT)))
    {
//      if(N->txt == NULL) fprintf(stderr, "Found case 1\n");
      N->optimal |= OPT_OPT;
    }

    if(N->optimal&OPT_OPT && N->txt==NULL)
    if((N1=N->next) && (N1->optimal&OPT_OPT))
    if((N2=N1->next) && (N2->optimal&OPT_OPT) && N2->txt==NULL)
    {
      statetrans(N->state, N->trans, &s0);
      statetrans(N2->state, N2->trans, &s2);
      if(!statediff(s0,s2,NULL))
      {
        statetrans(N1->state, N1->trans, &s1);
	statediff(s0, s1, &(N1->trans));
	N1->state = s0;
	N1->next = N2->chld;
	N->next = N2->next;
	free(N2);
	for(N2=N->chld; N2->next; N2=N2->next);
	N2->next = N1;
//        fprintf(stderr, "Found case 2\n");
      }
    }

    if(*stack==tr)
      break;

    if(*stack == (*(stack-1))->chld)
      goto optimalizer_next;
    goto optimalizer_upstack;
  }
  if(stack!=stkbase) fprintf(stderr,"stack failed in mergetext!\n");
  if(*stack!=tr) fprintf(stderr,"stack may have failed in mergetext!\n");
  return 0;
}

char *parse(char *c,P curnode) {
  char *c2, ot;
  if(*c=='<') {
    if(*(c+1)=='/') {*c='\0'; while(*c++!='>'); return c;}
    curnode->chld=newPT();
    curnode->trans=tag2trans(*(c+1));
    statetrans(curnode->state,curnode->trans,&(curnode->chld->state));
    while(*c++!='>');
    c=parse(c,curnode->chld);
    if(*c=='\0') return c;
    if(*c=='<' && *(c+1)=='/') {*c='\0'; while(*c++!='>'); return c;}
    curnode->next=newPT();
    curnode->next->state=curnode->state;
    c2=parse(c,curnode->next);
    return c2;
  }
  else
  {
    if(*c!='\0') {curnode->txt=c; curnode->optimal|=OPT_OPT;}
    ot=1;
    while(*c!='<'&&*c!='\0') { if(!isspace(*c)) ot=0; c++;}
    if(ot)
      curnode->optimal|=OPT_WS;
    if(*c=='\0') return c;
    if(*(c+1)=='/') {*c='\0'; while(*c++!='>'); return c;}
    curnode->next=newPT();
    curnode->next->state=curnode->state;
    c2=parse(c,curnode->next);
    *c='\0';
    return c2;
  }
}

void printtree(ParseTree *tr)
{
  static char buf[1000];
  trans_out1(tr->trans, buf);
//  printf("[%c%s]", (tr->optimal)?'-':' ',buf);
  printf("%s", buf);
  if(tr->txt) printf("%s", tr->txt);
  if(tr->chld)
  {
    printtree(tr->chld);
  }
  trans_out2(tr->trans, buf);
//  printf("[%s]", buf);
  printf("%s", buf);
  if(tr->next)
    printtree(tr->next);
}

char __all_str[6000000];
ParseTree head;

int main(int argc, char *argv[])
{
  int i,c;
  ParseTree *tr;

  i=atoi(argv[1]);
  ftime = (i-3)*CLOCKS_PER_SEC + clock();

  for(i=0;EOF!=(c=getchar());i++)
    __all_str[i]=c;
  __all_str[i]=0;

  head.chld  = NULL;
  head.next  = NULL;
  head.state = HI;
  head.trans = 0;
  head.txt   = NULL;
  head.optimal = 0;
  //initialise the stackptr
  stack=pstack;

  tr = &head;

  parse(__all_str, tr);

  //  printf("\noriginal input\n");
  //  printtree(tr);
  mergetext(tr);
  //  printtree(tr);
  killspace(tr);
  //  printtree(tr);

  compresstwig(tr);
//    printtree(tr);

//    printf("\n\n");

//  optimalizer(tr);
  movetreelocal(tr);
  tr=everything(tr); 


  printtree(tr);
#if 0 
  //printf("\nsimp3\n");
  tr=simplify3(tr);
  //printtree(tr);

  //printf("\nsimp3\n");
  tr=simplify3(tr);
  printtree(tr);
#endif
  return 0;
}
