#include<stdio.h>
#include "state.h"

int spacestatediff(State s0,State s1,State *d) {
   register bits diff,out,temp;
   register int cost;

   temp = ((s0|s1)&F_U)?(SPC_MASK|F_COLOR):SPC_MASK;

   diff=temp&(s0^s1)&((s0&s1)>>16);
   //first check if PL is needed
   if( (PLNEED&diff&s0) || ((s0&F_U)>(s1&F_U)) ) { //ie only if turning off, or u decreasing
      out=F_PL; cost=COST_PL;
      diff=temp&((s0&~PLOFF)^s1)&((s0&s1)>>16);
      //printf("PL ");
   } else {out=0; cost=0;}
   if(diff&F_SIZE) { //handle size change
      out|=(s1&F_SIZE);
      cost+=COST_SIZE;
      diff&=~F_SIZE;
      //printf("%d ",(s1&F_SIZE)/F_SIZE1);
   }
   if(diff&F_COLOR) { //handle color change
      out|=(s1&F_COLOR);
      cost+=COST_COLOR;
      diff&=~F_COLOR;
      //printf("c ");
   }
   if(diff&F_U) { //handle underline change
      if(out&F_PL) out|=(temp=s1&F_U);
      else out|=(temp=(s1&F_U)-(s0&F_U));
      cost+=COST_U*(temp/F_U1);
      diff&=~F_U;
      //for(temp/=F_U1;temp>0;temp--) printf("U ");
   }
   //handle booleans and underlines
   out|=(diff&F_BOOL);
   //if(diff&F_B) cost+=COST_B;// printf("B ");}
   //if(diff&F_I) cost+=COST_I;// printf("I ");}
   //if(diff&F_EM) cost+=COST_EM;// printf("EM ");}
   //if(diff&F_S) cost+=COST_S;// printf("S ");}
   if(diff&F_TT) cost+=COST_TT;// printf("TT ");}
   if(d!=NULL) *d=out;
//   printf("total cost=%d, %x, %x\n",cost,s0,s1);
   return cost;
}

int statediff(State s0,State s1,State *d) {
   register bits diff,out,temp;
   register int cost;

   diff=(s0^s1)&((s0&s1)>>16);
   //first check if PL is needed
   if( (PLNEED&diff&s0) || ((s0&F_U)>(s1&F_U)) ) { //ie only if turning off, or u decreasing
      out=F_PL; cost=COST_PL;
      diff=((s0&~PLOFF)^s1)&((s0&s1)>>16);
      //printf("PL ");
   } else {out=0; cost=0;}
   if(diff&F_SIZE) { //handle size change
      out|=(s1&F_SIZE);
      cost+=COST_SIZE;
      diff&=~F_SIZE;
      //printf("%d ",(s1&F_SIZE)/F_SIZE1);
   }
   if(diff&F_COLOR) { //handle color change
      out|=(s1&F_COLOR);
      cost+=COST_COLOR;
      diff&=~F_COLOR;
      //printf("c ");
   }
   if(diff&F_U) { //handle underline change
      if(out&F_PL) out|=(temp=s1&F_U);
      else out|=(temp=(s1&F_U)-(s0&F_U));
      cost+=COST_U*(temp/F_U1);
      diff&=~F_U;
      //for(temp/=F_U1;temp>0;temp--) printf("U ");
   }
   //handle booleans and underlines
   out|=(diff&F_BOOL);
   if(diff&F_B) cost+=COST_B;// printf("B ");}
   if(diff&F_I) cost+=COST_I;// printf("I ");}
   if(diff&F_EM) cost+=COST_EM;// printf("EM ");}
   if(diff&F_S) cost+=COST_S;// printf("S ");}
   if(diff&F_TT) cost+=COST_TT;// printf("TT ");}
   if(d!=NULL) *d=out;
//   printf("total cost=%d, %x, %x\n",cost,s0,s1);
   return cost;
}

void statetrans(State s0,State t,State *s1) {
   register bits temp,out;
   if(s1==NULL) return;
   out=s0;
   //PL is done first
   if(t&F_PL) {out&=~(PLOFF|F_PL);}
   //then those that need PL: B I S TT
   out|=t&PLNEED;
   //then EM toggle
   out^=t&F_EM; if((t&F_S)|(s0&F_S)) out&=~F_EM;
   //underlines to add?
   if(t&F_U) {
      temp=(out&F_U)+(t&F_U);
      if(temp>F_U) temp=F_U;
      out&=~F_U; out |=temp;
   }
   //color substitution?
   if(t&F_COLOR) {out&=~F_COLOR; out|=t&F_COLOR;}
   //size substitution?
   if(t&F_SIZE) {out&=~F_SIZE; out|=t&F_SIZE;}
   *s1=out;
}

void transtrans(State s0,State t,State *s1) {
   register bits temp,out;
   if(s1==NULL) return;
   out=s0;
   //PL is done first
   if(t&F_PL) {out&=~PLOFF; out|=F_PL;}
   //then those that need PL: B I S TT
   out|=t&PLNEED;
   //then EM toggle
   out^=t&F_EM; if((t&F_S)|(s0&F_S)) out&=~F_EM;
   //underlines to add?
   if(t&F_U) {
      temp=(out&F_U)+(t&F_U);
      if(temp>F_U) temp=F_U;
      out&=~F_U; out |=temp;
   }
   //color substitution?
   if(t&F_COLOR) {out&=~F_COLOR; out|=(t&F_COLOR);}
   //size substitution?
   if(t&F_SIZE) {out&=~F_SIZE; out|=(t&F_SIZE);}
   *s1=out;
}

int commonfac_incomplete(State t0,State t1,State *com,State *t0b,State *t1b) {
   register bits temp,temp1,out; register int cost=0;
   temp=t0; temp1=temp^(t1); out=0;
   if((temp&F_COLOR)&&!(temp1&F_COLOR)) {out|=temp&F_COLOR; cost+=COST_COLOR;}
   if((temp&F_SIZE )&&!(temp1&F_SIZE )) {out|=temp&F_SIZE ; cost+=COST_SIZE ;}
   temp=t0&t1;
   if(temp&F_PL) {cost+=COST_PL; out|=F_PL;}
   if(temp&F_B) {cost+=COST_B; out|=F_B;}
   if(temp&F_I) {cost+=COST_I; out|=F_I;}
   if(temp&F_EM) {cost+=COST_EM; out|=F_EM;} //also.. situation with s?
   if(temp&F_S) {cost+=COST_S; out|=F_S;}
   if(temp&F_TT) {cost+=COST_TT; out|=F_TT;}
   if(com) *com=out;
   //then, if we want the un-factored inputs
   if(t0b||t1b) {
      if(out&F_COLOR) out|=F_COLOR;
      if(out&F_SIZE) out|=F_SIZE;
      if(t0b) *t0b=t0&~out;
      if(t1b) *t1b=t1&~out;
   }
   return cost;
}

State tag2trans(char tag) {
  State t=0;
   switch(tag) {
   case 'B': t=F_B; break;
   case 'I': t=F_I; break;
   case 'E': t=F_EM; break;
   case 'S': t=F_S; break;
   case 'T': t=F_TT; break;
   case 'U': t=F_U1; break;
   case 'P': t=F_PL; break;
   //numerals
   case '0': t=SIZE(0); break;
   case '1': t=SIZE(1); break;
   case '2': t=SIZE(2); break;
   case '3': t=SIZE(3); break;
   case '4': t=SIZE(4); break;
   case '5': t=SIZE(5); break;
   case '6': t=SIZE(6); break;
   case '7': t=SIZE(7); break;
   case '8': t=SIZE(8); break;
   case '9': t=SIZE(9); break;
   //colours
   case 'r': t=COLR; break;
   case 'g': t=COLG; break;
   case 'b': t=COLB; break;
   case 'c': t=COLC; break;
   case 'm': t=COLM; break;
   case 'y': t=COLY; break;
   case 'k': t=COLK; break;
   case 'w': t=COLW; break;
   }
   return t;
}

int trans_out1(State t,char *buf) { //returns number of characters
   register int i,temp;
 
   i=0;
   //first check if PL is needed
   if(F_PL&t) {buf[i++]='<'; buf[i++]='P'; buf[i++]='L'; buf[i++]='>';}
   if(t&F_SIZE) {buf[i++]='<'; buf[i++]='0'-1+((t&F_SIZE)/F_SIZE1); buf[i++]='>';}
   if(t&F_COLOR) {
      buf[i++]='<';
      switch(t&F_COLOR) {
         case COLR: buf[i++]='r'; break;
         case COLG: buf[i++]='g'; break;
         case COLB: buf[i++]='b'; break;
         case COLC: buf[i++]='c'; break;
         case COLM: buf[i++]='m'; break;
         case COLY: buf[i++]='y'; break;
         case COLK: buf[i++]='k'; break;
         case COLW: buf[i++]='w'; break;
      }
      buf[i++]='>';
   }
   for(temp=(t&F_U)/F_U1;temp>0;temp--) {buf[i++]='<'; buf[i++]='U'; buf[i++]='>';}
   if(t&F_B)  {buf[i++]='<'; buf[i++]='B'; buf[i++]='>';}
   if(t&F_I)  {buf[i++]='<'; buf[i++]='I'; buf[i++]='>';}
   if(t&F_EM) {buf[i++]='<'; buf[i++]='E'; buf[i++]='M'; buf[i++]='>';}
   if(t&F_S)  {buf[i++]='<'; buf[i++]='S'; buf[i++]='>';}
   if(t&F_TT) {buf[i++]='<'; buf[i++]='T'; buf[i++]='T'; buf[i++]='>';}
   buf[i]=0;
   return i;
}

int trans_out2(State t,char *buf) { //returns number of characters
   register int i,temp;
 
   i=0;
   if(t&F_TT) {buf[i++]='<'; buf[i++]='/'; buf[i++]='T'; buf[i++]='T'; buf[i++]='>';}
   if(t&F_S)  {buf[i++]='<'; buf[i++]='/'; buf[i++]='S'; buf[i++]='>';}
   if(t&F_EM) {buf[i++]='<'; buf[i++]='/'; buf[i++]='E'; buf[i++]='M'; buf[i++]='>';}
   if(t&F_I)  {buf[i++]='<'; buf[i++]='/'; buf[i++]='I'; buf[i++]='>';}
   if(t&F_B)  {buf[i++]='<'; buf[i++]='/'; buf[i++]='B'; buf[i++]='>';}
   for(temp=((t&F_U)/F_U1);temp>0;temp--) {buf[i++]='<'; buf[i++]='/'; buf[i++]='U'; buf[i++]='>';}
   if(t&F_COLOR) {
      buf[i++]='<'; buf[i++]='/';
      switch(t&F_COLOR) {
         case COLR: buf[i++]='r'; break;
         case COLG: buf[i++]='g'; break;
         case COLB: buf[i++]='b'; break;
         case COLC: buf[i++]='c'; break;
         case COLM: buf[i++]='m'; break;
         case COLY: buf[i++]='y'; break;
         case COLK: buf[i++]='k'; break;
         case COLW: buf[i++]='w'; break;
      }
      buf[i++]='>';
   }
   if(t&F_SIZE) {buf[i++]='<'; buf[i++]='/'; buf[i++]='0'-1+((t&F_SIZE)/F_SIZE1); buf[i++]='>';}
   //lastly check if PL is needed
   if(F_PL&t) {buf[i++]='<'; buf[i++]='/'; buf[i++]='P'; buf[i++]='L'; buf[i++]='>';}
   buf[i]=0;
   return i;
}

#if 0
int main(void) {
   int s1,s2,d;
   char buf[100];
   while(1) {
      scanf("%x %x",&s1,&s2);
      if(s1==0&&s2==0) break;
      statediff(s1,s2,&d);
      buf[trans_out1(s1,buf)]='\0';
      printf("s1 in %s\n",buf);
      buf[trans_out2(s1,buf)]='\0';
      printf("s1 out %s\n",buf);
      buf[trans_out1(s2,buf)]='\0';
      printf("s2 in %s\n",buf);
      buf[trans_out2(s2,buf)]='\0';
      printf("s2 out %s\n",buf);
      buf[trans_out1(d,buf)]='\0';
      printf("d in %s\n",buf);
      buf[trans_out2(d,buf)]='\0';
      printf("d out %s\n",buf);
   }
   return 0;
}
#endif

